(ns document-storage.protocol)

(defprotocol storage
  "Base Protocol for document storages"
  (load-document [ds id repository] "Load document from a repository")
  (save-document [ds id document repository] "Save new/initial version of document in a repository")
  (delete-document [ds id repository] "Delete a specific document in a repository")
  (list-documents [ds repository] "List all documents in a repository")
  (find-documents [ds query repository] "Find documents with a given query in a repository")
  (list-repositories [ds] "List all repositories")
  (list-versions [ds id repository] "List all version of a specific document in a repository")
  (load-version [ds id version repository] "Load a specific document version in a repository")
  (get-document-size [ds id repository] "Calculate the current document size")
  (init-storage [ds] "Start a document storage")
  (shutdown [ds] "Stop a document storage"))
